# events-ingestion-client
The Observation platform's Events Ingestion API

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 0.0.1
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen
For more information, please visit [https://datakitchen.io](https://datakitchen.io)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import events_ingestion_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import events_ingestion_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import events_ingestion_client
from events_ingestion_client.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = events_ingestion_client.EventsApi(events_ingestion_client.ApiClient(configuration))
body = events_ingestion_client.RunStateSchemaRequestBody() # RunStateSchemaRequestBody | Data describing the event.
event_source = 'API' # str | Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users. (optional) (default to API)

try:
    # AddRunState Event
    api_instance.post_add_run_state(body, event_source=event_source)
except ApiException as e:
    print("Exception when calling EventsApi->post_add_run_state: %s\n" % e)

# create an instance of the API class
api_instance = events_ingestion_client.EventsApi(events_ingestion_client.ApiClient(configuration))
body = events_ingestion_client.CloseRunSchemaRequestBody() # CloseRunSchemaRequestBody | Data describing the event.
event_source = 'API' # str | Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users. (optional) (default to API)

try:
    # CloseRun Event
    api_instance.post_close_run(body, event_source=event_source)
except ApiException as e:
    print("Exception when calling EventsApi->post_close_run: %s\n" % e)

# create an instance of the API class
api_instance = events_ingestion_client.EventsApi(events_ingestion_client.ApiClient(configuration))
body = events_ingestion_client.CustomEventSchemaRequestBody() # CustomEventSchemaRequestBody | Data describing a custom event.
event_source = 'API' # str | Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users. (optional) (default to API)

try:
    # Custom Event
    api_instance.post_custom(body, event_source=event_source)
except ApiException as e:
    print("Exception when calling EventsApi->post_custom: %s\n" % e)

# create an instance of the API class
api_instance = events_ingestion_client.EventsApi(events_ingestion_client.ApiClient(configuration))
body = events_ingestion_client.MessageLogEventSchemaRequestBody() # MessageLogEventSchemaRequestBody | Data describing the event.
event_source = 'API' # str | Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users. (optional) (default to API)

try:
    # MessageLog Event
    api_instance.post_message_log(body, event_source=event_source)
except ApiException as e:
    print("Exception when calling EventsApi->post_message_log: %s\n" % e)

# create an instance of the API class
api_instance = events_ingestion_client.EventsApi(events_ingestion_client.ApiClient(configuration))
body = events_ingestion_client.MetricLogSchemaRequestBody() # MetricLogSchemaRequestBody | Data describing the event.
event_source = 'API' # str | Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users. (optional) (default to API)

try:
    # LogMetric Event
    api_instance.post_metric_log(body, event_source=event_source)
except ApiException as e:
    print("Exception when calling EventsApi->post_metric_log: %s\n" % e)

# create an instance of the API class
api_instance = events_ingestion_client.EventsApi(events_ingestion_client.ApiClient(configuration))
body = events_ingestion_client.TaskStatusSchemaRequestBody() # TaskStatusSchemaRequestBody | Data describing the event.
event_source = 'API' # str | Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users. (optional) (default to API)

try:
    # TaskStatus Event
    api_instance.post_task_status(body, event_source=event_source)
except ApiException as e:
    print("Exception when calling EventsApi->post_task_status: %s\n" % e)

# create an instance of the API class
api_instance = events_ingestion_client.EventsApi(events_ingestion_client.ApiClient(configuration))
body = events_ingestion_client.TestResultSchemaRequestBody() # TestResultSchemaRequestBody | Data describing the event.
event_source = 'API' # str | Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users. (optional) (default to API)

try:
    # TestResults Event
    api_instance.post_test_result(body, event_source=event_source)
except ApiException as e:
    print("Exception when calling EventsApi->post_test_result: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *dev-api.datakitchen.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*EventsApi* | [**post_add_run_state**](docs/EventsApi.md#post_add_run_state) | **POST** /events/v1/add-run-state | AddRunState Event
*EventsApi* | [**post_close_run**](docs/EventsApi.md#post_close_run) | **POST** /events/v1/close-run | CloseRun Event
*EventsApi* | [**post_custom**](docs/EventsApi.md#post_custom) | **POST** /events/v1/custom | Custom Event
*EventsApi* | [**post_message_log**](docs/EventsApi.md#post_message_log) | **POST** /events/v1/message-log | MessageLog Event
*EventsApi* | [**post_metric_log**](docs/EventsApi.md#post_metric_log) | **POST** /events/v1/metric-log | LogMetric Event
*EventsApi* | [**post_task_status**](docs/EventsApi.md#post_task_status) | **POST** /events/v1/task-status | TaskStatus Event
*EventsApi* | [**post_test_result**](docs/EventsApi.md#post_test_result) | **POST** /events/v1/test-results | TestResults Event

## Documentation For Models

 - [CloseRunSchemaRequestBody](docs/CloseRunSchemaRequestBody.md)
 - [CustomEventSchemaRequestBody](docs/CustomEventSchemaRequestBody.md)
 - [HTTPErrorSchema](docs/HTTPErrorSchema.md)
 - [MessageLogEventSchemaRequestBody](docs/MessageLogEventSchemaRequestBody.md)
 - [MetricLogSchemaRequestBody](docs/MetricLogSchemaRequestBody.md)
 - [RunStateSchemaRequestBody](docs/RunStateSchemaRequestBody.md)
 - [TaskStatusSchemaRequestBody](docs/TaskStatusSchemaRequestBody.md)
 - [TestReport](docs/TestReport.md)
 - [TestResultSchemaRequestBody](docs/TestResultSchemaRequestBody.md)

## Documentation For Authorization

 All endpoints do not require authorization.


## Author

support@datakitchen.io
