# coding: utf-8

"""
    Events Ingestion API

    The Observation platform's Events Ingestion API  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@datakitchen.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from events_ingestion_client.api_client import ApiClient


class EventsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def post_add_run_state(self, body, **kwargs):  # noqa: E501
        """AddRunState Event  # noqa: E501

        Applies a custom state to an open run. Specify the name of the pipeline and run_tag of the run. If no run_tag is specified, the custom state is applied to the default open run for the pipeline. Run states describe the progress or results of a pipeline execution. Standard run state types are ERROR, WARNING, and INFO. Custom run states may be used to label runs with information not typically captured, such as disk usage.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_add_run_state(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param RunStateSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_add_run_state_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_add_run_state_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_add_run_state_with_http_info(self, body, **kwargs):  # noqa: E501
        """AddRunState Event  # noqa: E501

        Applies a custom state to an open run. Specify the name of the pipeline and run_tag of the run. If no run_tag is specified, the custom state is applied to the default open run for the pipeline. Run states describe the progress or results of a pipeline execution. Standard run state types are ERROR, WARNING, and INFO. Custom run states may be used to label runs with information not typically captured, such as disk usage.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_add_run_state_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param RunStateSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'event_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_add_run_state" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_add_run_state`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'event_source' in params:
            header_params['EVENT-SOURCE'] = params['event_source']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/events/v1/add-run-state', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_close_run(self, body, **kwargs):  # noqa: E501
        """CloseRun Event  # noqa: E501

        Sets an open run to CLOSED, and prevents new events from being associated with the run. Specify the name of the pipeline and run_tag of the run. If no run_tag is specified, the default open run for the pipeline will be closed. Post a CloseRun event to end an open run of a pipeline and start a new run of the same pipeline.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_close_run(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CloseRunSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_close_run_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_close_run_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_close_run_with_http_info(self, body, **kwargs):  # noqa: E501
        """CloseRun Event  # noqa: E501

        Sets an open run to CLOSED, and prevents new events from being associated with the run. Specify the name of the pipeline and run_tag of the run. If no run_tag is specified, the default open run for the pipeline will be closed. Post a CloseRun event to end an open run of a pipeline and start a new run of the same pipeline.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_close_run_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CloseRunSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'event_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_close_run" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_close_run`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'event_source' in params:
            header_params['EVENT-SOURCE'] = params['event_source']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/events/v1/close-run', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_custom(self, body, **kwargs):  # noqa: E501
        """Custom Event  # noqa: E501

        Generates a custom event with the value provided for the 'data' key. The Events Ingestion API does not define the behavior of this event nor validate data key values, to provide flexibility for multiple use cases. Warning - This endpoint is not intended for use by end users.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_custom(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CustomEventSchemaRequestBody body: Data describing a custom event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_custom_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_custom_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_custom_with_http_info(self, body, **kwargs):  # noqa: E501
        """Custom Event  # noqa: E501

        Generates a custom event with the value provided for the 'data' key. The Events Ingestion API does not define the behavior of this event nor validate data key values, to provide flexibility for multiple use cases. Warning - This endpoint is not intended for use by end users.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_custom_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CustomEventSchemaRequestBody body: Data describing a custom event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'event_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_custom" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_custom`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'event_source' in params:
            header_params['EVENT-SOURCE'] = params['event_source']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/events/v1/custom', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_message_log(self, body, **kwargs):  # noqa: E501
        """MessageLog Event  # noqa: E501

        Logs a string message related to the pipeline run, and optionally related to a specific task. Post a MessageLog event to capture error, warning, or debugging messages from external tools and scripts.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_message_log(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param MessageLogEventSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_message_log_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_message_log_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_message_log_with_http_info(self, body, **kwargs):  # noqa: E501
        """MessageLog Event  # noqa: E501

        Logs a string message related to the pipeline run, and optionally related to a specific task. Post a MessageLog event to capture error, warning, or debugging messages from external tools and scripts.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_message_log_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param MessageLogEventSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'event_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_message_log" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_message_log`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'event_source' in params:
            header_params['EVENT-SOURCE'] = params['event_source']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/events/v1/message-log', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_metric_log(self, body, **kwargs):  # noqa: E501
        """LogMetric Event  # noqa: E501

        Logs the value of a user-defined datum of interest, such as a row count. Post a MetricLog event to track the value of a metric through a run or for comparing the value of the metric across multiple runs.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_metric_log(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param MetricLogSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_metric_log_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_metric_log_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_metric_log_with_http_info(self, body, **kwargs):  # noqa: E501
        """LogMetric Event  # noqa: E501

        Logs the value of a user-defined datum of interest, such as a row count. Post a MetricLog event to track the value of a metric through a run or for comparing the value of the metric across multiple runs.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_metric_log_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param MetricLogSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'event_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_metric_log" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_metric_log`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'event_source' in params:
            header_params['EVENT-SOURCE'] = params['event_source']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/events/v1/metric-log', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_task_status(self, body, **kwargs):  # noqa: E501
        """TaskStatus Event  # noqa: E501

        Changes the status of the specified task in the pipeline. Post a TaskStatus event to tell the platform that a task has started or ended with a certain result.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_task_status(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TaskStatusSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_task_status_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_task_status_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_task_status_with_http_info(self, body, **kwargs):  # noqa: E501
        """TaskStatus Event  # noqa: E501

        Changes the status of the specified task in the pipeline. Post a TaskStatus event to tell the platform that a task has started or ended with a certain result.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_task_status_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TaskStatusSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'event_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_task_status" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_task_status`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'event_source' in params:
            header_params['EVENT-SOURCE'] = params['event_source']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/events/v1/task-status', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_test_result(self, body, **kwargs):  # noqa: E501
        """TestResults Event  # noqa: E501

        Reports the results of a test or a set of tests. Receives a list of test results by test name and status (PASSED, FAILED, or WARNING). Post a TestResultsEvent event to send results from an external tool to the Observe platform to track and report on runs and outcomes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_test_result(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TestResultSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_test_result_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_test_result_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_test_result_with_http_info(self, body, **kwargs):  # noqa: E501
        """TestResults Event  # noqa: E501

        Reports the results of a test or a set of tests. Receives a list of test results by test name and status (PASSED, FAILED, or WARNING). Post a TestResultsEvent event to send results from an external tool to the Observe platform to track and report on runs and outcomes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_test_result_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TestResultSchemaRequestBody body: Data describing the event. (required)
        :param str event_source: Set the source of the event. If unset, the Events Ingestion API will assume the source of the Event is API. Warning - This parameter is not intended for use by end users.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'event_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_test_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_test_result`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'event_source' in params:
            header_params['EVENT-SOURCE'] = params['event_source']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/events/v1/test-results', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
